searchNodes=[{"doc":"Vela is a tiny library providing easy management of validated cached state with some history. Including use Vela in your module would turn the module into struct, setting field accordingly to the specification, passed as a parameter. Vela allows the following configurable parameters per field: limit — length of the series to keep (default 5) validator — validation function as either module implementing Vela.Validator behaviour, or a local function (default fn _, _, _ -&gt; true end) compare_by — comparator extraction function to extract the value, to be used for comparison, from the underlying terms (by default it returns the whole value) invalidator — the function to be used to invalidate the accumulated values errors — number of errors to keep (default: 5) Also, Vela accepts :mη keyword parameter for the cases when the consumer needs the very custom meta to be passed to the struct. Vela implements Access behaviour. Usage defmodule Vela.Test do use Vela, series1: [limit: 3, errors: 1], # no validation series2: [limit: 2, validator: Vela.Test] series3: [ compare_by: &amp;Vela.Test.comparator/1, invalidator: &amp;Vela.Test.invalidator/1 ] @behaviour Vela.Validator @impl Vela.Validator def valid?(%__MODULE__{} = state, key, value) do value &gt; 0 end @spec comparator(%{created_at :: DateTime.t()}) :: DateTime.t() def comparator(%{created_at: created_at}), do: created_at @spec invalidator(date :: DateTime.t()) :: boolean() def invalidator(date), do: DateTime.diff(DateTime.utc_now(), date) &gt; 300 end In the example above, before any structure update attempt (via Access,) this valid?/3 function would be called. If it returns true, the value gets inserted / updated, and the series behind is truncated if needed. It it returns false, the state is not updated, and the value is put into the map under __errors__ key of the struct. The length of errors is also configurable via errors: keyword parameter.","ref":"Vela.html","title":"Vela","type":"module"},{"doc":"","ref":"Vela.html#flat_map/2","title":"Vela.flat_map/2","type":"function"},{"doc":"","ref":"Vela.html#map/2","title":"Vela.map/2","type":"function"},{"doc":"Represents a key in the Vela structure","ref":"Vela.html#t:serie/0","title":"Vela.serie/0","type":"type"},{"doc":"Represents the struct created by this behaviour module","ref":"Vela.html#t:t/0","title":"Vela.t/0","type":"type"},{"doc":"Represents a value in the Vela structure","ref":"Vela.html#t:value/0","title":"Vela.value/0","type":"type"},{"doc":"The validator behaviour, implementations are used by Vela to validate new values to be inserted into the state.","ref":"Vela.Validator.html","title":"Vela.Validator","type":"behaviour"},{"doc":"When implemented, the module might be passed as validator to use Vela","ref":"Vela.Validator.html#c:valid?/3","title":"Vela.Validator.valid?/3","type":"callback"},{"doc":"The generic exception thrown when the access in invalid. Parameters: source the source of the exception field the field the access to has failed","ref":"Vela.AccessError.html","title":"Vela.AccessError","type":"exception"},{"doc":"Vela The tiny library to ease handling expiring invalidated cached series","ref":"readme.html","title":"Vela","type":"extras"},{"doc":"def deps do [ {:vela, &quot;~&gt; 0.1&quot;} ] end","ref":"readme.html#installation","title":"Vela - Installation","type":"extras"},{"doc":"","ref":"readme.html#documentation","title":"Vela - Documentation","type":"extras"}]